<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <CommonHeader
      :title="M.WL_ALL_WORKLOADS"
      :description="M.WL_ALL_WORKLOADS_DESCRIPTION"
      >
      <v-btn small :disabled="!enabledActions.create" @click="$emit('newWorkload')">New workload</v-btn>
      <v-btn small :disabled="!enabledActions.create" @click="exportWorkloads()">Export All</v-btn>
    </CommonHeader>

    <Filterbox
      :filteredSize="filteredWorkloads.length"
      :itemsName="['workload', 'workloads']"
      v-on:changed="filterkey=$event.key"
    />

    <v-list three-line>
      <v-list-item-group color="primary">
        <WorkloadSummary
          :key="workload.id"
          v-for="(workload) in filteredWorkloads"
          :item="workload"
          v-on:selected="$emit('viewWorkload', workload)"
        />
      </v-list-item-group>
    </v-list>

    <v-dialog v-model="export_dialog" max-width="500px">
      <v-card>
        <v-card-title>
          <span>Export Workloads</span>
        </v-card-title>
        <v-card-text>
        One or more workloads inherit from generic workloads.<br/> How do you want to export them?<br/>
        <v-radio-group v-model="export_flat">
          <v-radio label="Preserve the workload hierarchy" :value="false"></v-radio>
          <v-radio label="Collapse inherited properties in most-specific workloads" :value="true"></v-radio>
        </v-radio-group>
        </v-card-text>
        <v-card-actions>
          <v-spacer/>
          <v-btn @click="export_dialog = false">Cancel</v-btn>
          <v-btn class="primary" v-on:click="doExportWorkload()">Export</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

  </v-container>

</template>


<script>

import CommonHeader from '../common/CommonHeader.vue';
import WorkloadSummary from './WorkloadSummary.vue';
import Filterbox from '../common/Filterbox.vue';
import { MESSAGES } from "../common/messages";

import { mapGetters } from "vuex";

import { getWorkloadSharingLevel } from '../common/benchsuite.js';



export default {

  name: 'WorkloadsList',

 components: {
    CommonHeader,
    WorkloadSummary,
    Filterbox
  },

  data: () => ({
    M : MESSAGES,
    workloads: [],
    filterkey: "",
    enabledActions: {
      create:false
    },
    export_dialog:false,
    export_flat:false
  }),

  mounted () {
    this.$store.commit('fbkon')
    this.$http
      .get(this.$REST_BASE_URL + '/workloads/?resolve=true')
      .then(response => (this.workloads = response.data))
      .finally(() => {this.$store.commit('fbkoff')});
    // update actions
    this.$http
          .get(this.$REST_BASE_URL + "/workloads/user_actions")
      .then(response => {
        this.enabledActions.create = response.data.create=="True";
      })
    this.$emit("title", "Workloads");
  },

  methods: {
    exportWorkloads: function() {
      var ask=false;
      for(var i in this.workloads) {
        if(this.workloads[i].parent_workload_id) {
          ask=true;
          break;
        }
      }
      if(ask) {
        this.export_dialog=true;
      } else {
        this.doExportWorkload();
      }
    },
    doExportWorkload: function() {
      this.export_dialog=false;
      var link = document.createElement("a");
      link.setAttribute("href", this.$REST_BASE_URL + '/workloads/download?flat='+this.export_flat);
      link.click();
    },


  },

  computed: {
    ...mapGetters(["getProfile"]),
    filteredWorkloads() {
      return this.workloads.filter(item => {

        //
        // Filter out all "old" workloads that does not have a "name" field
        // but have "workload_name"
        //
        if(!item.name)
          return false

        if(!this.filterkey)
          return true;
        var text = "";
        for(var k in item) {
          text += " " + item[k];
        }
        text += " " + getWorkloadSharingLevel(item);
        text += (item.abstract ? " abstract" : "");
        return text.toLowerCase().includes(this.filterkey.toLowerCase());
      }).sort((a,b) => {return (b.name.toLowerCase()+b.id) < (a.name.toLowerCase()+a.id) ? 1 : -1});
    }
  }

};

</script>

<style>
div.xprovider-name {
  font-weight:bold;
}
</style>
